Procedure DrawGoraudPoly8(poly:TPolygonPtr; Num:byte; Color:word; Where:TPageType);
{ poly - polygon structure }
{ Num  - number of vertexes in poly}
{ Color - base filling color for flat polygons}
{ Note: Vertexes must go in clockwise direction }
{ Using z coordinate as color index}
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;

    LeftColorStep,RightColorStep,LeftColor,RightColor,ColorStep:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;
    BaseColor:fixed;

Procedure LeftSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 1 then NewVertex=vertex number 4}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      LeftVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      LeftVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, LeftSectionSize will always be >0}
      LeftSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if LeftSectionSize=0 then exit;
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      {divide xlen by ylen}
      CurrLeftX:=Poly^[vrtx1].x;
      LeftStepX:=mFixedDiv(Poly^[vrtx2].x-CurrLeftX,height);

--      DECLARE var prestep:fixed; begin
--         prestep:=mFixedRound(Poly^[vrtx1].y) - Poly^[vrtx1].y;
--         CurrLeftX+:=mFixedMul(prestep,LeftStepX);
--      end;

      LeftColor:=Poly^[vrtx1].color;
      LeftColorStep:=mFixedDiv(Poly^[vrtx2].color-LeftColor,height);
      LeftColor+:=BaseColor;
  end;

Procedure RightSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 4 then NewVertex=vertex number 1}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      RightVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      RightVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, RightSectionSize will always be >0}
      RightSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if RightSectionSize=0 then exit;
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      {divide xlen by ylen}
      CurrRightX:=Poly^[vrtx1].x;
      RightStepX:=mFixedDiv(Poly^[vrtx2].x-CurrRightX,height);

--      DECLARE var prestep:fixed; begin
--         prestep:=mFixedRound(Poly^[vrtx1].y) - Poly^[vrtx1].y;
--         CurrRightX+:=mFixedMul(prestep,LeftStepX);
--      end;
      RightColor:=Poly^[vrtx1].color;
      RightColorStep:=mFixedDiv(Poly^[vrtx2].color-RightColor,height);
      RightColor+:=BaseColor;
  end;

var hsize:longint;
    temp,x:fixed;
Begin
   BaseColor:=color*65536; -- translate base color into 16.16 fixed
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection  {search for first usable section}
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hsize>0 then begin

      ColorStep:=mFixedDiv(RightColor-LeftColor,CurrRightX-CurrLeftX);
      asm
         mov edi,dword ptr Where
         add edi,offs
         add edi,x

         mov ebx,LeftColor
         mov edx,ColorStep
         ror ebx,16
         ror edx,16

         mov ecx,hsize
         mov esi,edx
         shr ecx,1
         mov dx,0
         jnc @@inner
         -- put alone pixel --
         mov [edi],bl
         add ebx,edx
         adc bx,si
         inc edi
         jcxz @@done
@@inner:

         mov al,bl
         add ebx,edx
         adc bx,si
         mov ah,bl
         add ebx,edx
         adc bx,si
         stosw
         dec ecx
         jnz @@inner
@@done:
      end;

   end;


   offs+:=Where.SizeX;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else begin
      CurrLeftX+:=LeftStepX;
      LeftColor+:=LeftColorStep;
   end;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else begin
      CurrRightX+:=RightStepX;
      RightColor+:=RightColorStep;
   end;

until false;
end;

Procedure DrawTransparentGoraudPoly8(poly:TPolygonPtr; Num:byte; Color:word; Where:TPageType);
{ poly - polygon structure }
{ Num  - number of vertexes in poly}
{ Color - base filling color for flat polygons}
{ Note: Vertexes must go in clockwise direction }
{ Using z coordinate as color index}
var n:integer;
    MinVrtx,MaxVrtx:integer;
    LeftVrtx,RightVrtx:integer;
    LeftStepX,RightStepX,CurrLeftX,CurrRightX:fixed;

    LeftColorStep,RightColorStep,LeftColor,RightColor,ColorStep:fixed;

    CurrY:fixed;
    LeftSectionSize,RightSectionSize:longint;
    MinY,MaxY:fixed;
    offs:dword;
    BaseColor:fixed;

Procedure LeftSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 1 then NewVertex=vertex number 4}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      LeftVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=LeftVrtx;
      Vrtx2:=LeftVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      LeftVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, LeftSectionSize will always be >0}
      LeftSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if LeftSectionSize=0 then exit;
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      {divide xlen by ylen}
      CurrLeftX:=Poly^[vrtx1].x;
      LeftStepX:=mFixedDiv(Poly^[vrtx2].x-CurrLeftX,height);

--      DECLARE var prestep:fixed; begin
--         prestep:=mFixedRound(Poly^[vrtx1].y) - Poly^[vrtx1].y;
--         CurrLeftX+:=mFixedMul(prestep,LeftStepX);
--      end;

      LeftColor:=Poly^[vrtx1].color;
      LeftColorStep:=mFixedDiv(Poly^[vrtx2].color-LeftColor,height);
      LeftColor+:=BaseColor;
  end;

Procedure RightSection;
  var Vrtx1,Vrtx2:integer;
      height:fixed;
--      prestep:fixed;
  begin
{$IFDEF VERTEXES_IN_CLOCKWISE_DIRECTION}
      {if we come to vertex number 4 then NewVertex=vertex number 1}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx+1;
      if Vrtx2>Num then Vrtx2:=1;
      RightVrtx:=Vrtx2;
{$ELSE}
      Vrtx1:=RightVrtx;
      Vrtx2:=RightVrtx-1;
      if Vrtx2<1 then Vrtx2:=Num;
      RightVrtx:=Vrtx2;
{$ENDIF}
      {because we go from up to down, RightSectionSize will always be >0}
      RightSectionSize:=mRound(Poly^[Vrtx2].y)-mRound(Poly^[Vrtx1].y);
      if RightSectionSize=0 then exit;
      height:=Poly^[vrtx2].y-Poly^[vrtx1].y;
      {divide xlen by ylen}
      CurrRightX:=Poly^[vrtx1].x;
      RightStepX:=mFixedDiv(Poly^[vrtx2].x-CurrRightX,height);

--      DECLARE var prestep:fixed; begin
--         prestep:=mFixedRound(Poly^[vrtx1].y) - Poly^[vrtx1].y;
--         CurrRightX+:=mFixedMul(prestep,LeftStepX);
--      end;
      RightColor:=Poly^[vrtx1].color;
      RightColorStep:=mFixedDiv(Poly^[vrtx2].color-RightColor,height);
      RightColor+:=BaseColor;
  end;

var hsize:longint;
    temp,x:fixed;
Begin
   BaseColor:=color*65536; -- translate base color into 16.16 fixed
   MinY:= 2140000000;
   MaxY:=-2140000000;
{ scan for max&min vertexes}
   for n:=1 to Num do begin
      temp:=Poly^[n].y;
      if temp<MinY then begin
         MinY:=temp;
         MinVrtx:=n
      end;
      if temp>MaxY then begin
         MaxY:=temp;
         MaxVrtx:=n
      end;
   end;
   LeftVrtx:=MinVrtx;  {left side starting vertex}
   RightVrtx:=MinVrtx;

   CurrY:=mRound(MinY);

   RightSectionSize:=0;
   LeftSectionSize:=0;
   while RightSectionSize<=0 do begin
     if RightVrtx=MaxVrtx then exit;
     RightSection  {search for first usable section}
   end;
   while LeftSectionSize<=0 do begin
     if LeftVrtx=MaxVrtx then exit;
     LeftSection
   end;

   offs:=CurrY*Where.SizeX;
repeat
   {get rounded size of horizontal line}
   x:=mRound(CurrLeftX);
   hsize:=mRound(CurrRightX)-x;
   if hsize>0 then begin

      ColorStep:=mFixedDiv(RightColor-LeftColor,CurrRightX-CurrLeftX);
      asm
         mov edi,dword ptr Where
         add edi,offs
         add edi,x

         mov edx,LeftColor
         ror edx,16

         mov esi,PTranspTable

         mov ecx,hsize
         xor ebx,ebx

         push ebp
         mov ebp,ColorStep
         ror ebp,16

         shr ecx,1
         jnc @@SkipOne
         -- put alone pixel --
         mov eax,[edi]
         mov bh,dl
         mov bl,al
         mov al,[esi+ebx]
         stosb
         add edx,ebp
         adc edx,0
         jcxz @@done
@@SkipOne:
         shr ecx,1
         jnc @@inner

         mov eax,[edi]
         mov bh,dl
         add edx,ebp
         mov bl,al
         adc edx,0
         mov al,[esi+ebx]


         mov bh,dl
         add edx,ebp
         mov bl,ah
         adc edx,0
         mov ah,[esi+ebx]
         stosw
         jcxz @@done
@@inner:
         -- get first pixel --
         mov eax,[edi]
         mov bh,dl
         add edx,ebp
         mov bl,al
         adc edx,0
         mov al,[esi+ebx]
         -- get second pixel --
         mov bh,dl
         add edx,ebp
         mov bl,ah
         adc edx,0
         mov ah,[esi+ebx]
         ror eax,16

         mov bh,dl
         add edx,ebp
         mov bl,al
         adc edx,0
         mov al,[esi+ebx]

         mov bh,dl
         add edx,ebp
         mov bl,ah
         adc edx,0
         mov ah,[esi+ebx]
         ror eax,16
         stosd
         dec ecx
         jnz @@inner
@@done:
         pop ebp
      end;

   end;


   offs+:=Where.SizeX;
   LeftSectionSize-:=1;
   RightSectionSize-:=1;

   if LeftSectionSize<=0 then
      while LeftSectionSize<=0 do begin
         if LeftVrtx=MaxVrtx then exit;
         LeftSection
      end
   else begin
      CurrLeftX+:=LeftStepX;
      LeftColor+:=LeftColorStep;
   end;

   if RightSectionSize<=0 then
      while RightSectionSize<=0 do begin
        if RightVrtx=MaxVrtx then exit;
        RightSection
      end
   else begin
      CurrRightX+:=RightStepX;
      RightColor+:=RightColorStep;
   end;

until false;
end;
